[segment .data align=16]
rand:	db	'rand',0
randn:	db	'randn',0


[segment .bss align=16 writable]
sz:	resd	1
mn:	resd	1
mu:	resd	1
nn:	resd	1
nu:	resd	1
rn:	resd	1
ru:	resd	1


[segment .text align=16]
extern	_mexAtExit
extern	_mexCallMATLAB
extern	_mexMakeArrayPersistent
extern	_mxCreateDoubleMatrix
extern	_mxDestroyArray
extern	_mxGetPr
global	_rande
global	_randn
global	_randp
global	_randu
global	_init
global	_done


;double rande(void)
;
_rande:call	_randu
	fldln2
	fxch
	fyl2x
       retn


align	16

;double randn(void)
;
_randn:	mov ecx,[nn]
	mov eax,[rn]
	sub ecx,byte 1
       jns	.1
	cmp dword [mn],byte 0
	push dword [mn]
       jz	.0
       call	_mxDestroyArray
.0:	sub esp,byte 124
	fnsave [esp+20]
	mov dword [esp+16],randn
	mov dword [esp+12],sz
	mov dword [esp+8],1
	mov dword [esp+4],mn
	mov dword [esp],1
       call	_mexCallMATLAB
	push dword [mn]
       call	_mexMakeArrayPersistent
	mov eax,[mn]
	mov [esp],eax
       call	_mxGetPr
	frstor [esp+24]
	add esp,132
	mov [rn],eax
	mov ecx,65535
.1:	mov [nn],ecx
	fld qword [eax+ecx*8]
       retn


align	16

;double randp(double lambda)
;
_randp:	fld qword [esp+4]	; L
	fldz
	fucomip st1
       jp	.0		; nan
       jz	.0		; zero
       ja	.1		; negative
	fld dword [lim]
	fucomip st1
       ja	.2
	fld st0			; L > 36
	fsqrt
       call	_randn
	fmulp st1,st0
	faddp st1,st0
	fldcw [fpcw]
	frndint			; fix(L + sqrt(L)*randn)
.0:    retn			; L == 0 || isnan(L)
.1:	fstp st0		; L < 0
	fld dword [nan]
       retn
.2:	push ebx
	mov ebx,-1
.3:    call	_rande
	faddp st1,st0
	fldz
	fucomip st1
	lea ebx,[ebx+1]
       jb	.3
	mov [esp+8],ebx
	fstp st0
	fild dword [esp+8]
	pop ebx
       retn


align	16

;double randu(void)
;
_randu:	mov ecx,[nu]
	mov eax,[ru]
	sub ecx,byte 1
       jns	.1
	cmp dword [mu],byte 0
	push dword [mu]
       jz	.0
       call	_mxDestroyArray
.0:	sub esp,byte 124
	fnsave [esp+20]
	mov dword [esp+16],rand
	mov dword [esp+12],sz
	mov dword [esp+8],1
	mov dword [esp+4],mu
	mov dword [esp],1
       call	_mexCallMATLAB
	push dword [mu]
       call	_mexMakeArrayPersistent
	mov eax,[mu]
	mov [esp],eax
       call	_mxGetPr
	frstor [esp+24]
	add esp,132
	mov [ru],eax
	mov ecx,65535
.1:	mov [nu],ecx
	fld qword [eax+ecx*8]
       retn


align	16

;void init(void)
;
_init:	xor eax,eax
	cmp [sz],eax
       jnz	.0
	mov [nn],eax
	mov [nu],eax
	mov [mn],eax
	mov [mu],eax
	mov [rn],eax
	mov [ru],eax
	push eax
	push dword _done
       call	_mexAtExit
	mov dword [esp],2
	push dword 1
       call	_mxCreateDoubleMatrix
	mov dword [esp+4],65536
	mov [esp],eax
	mov [sz],eax
       call	_mexMakeArrayPersistent
	mov eax,[sz]
	mov [esp],eax
       call	_mxGetPr
	fild dword [esp+4]
	fld1
	add esp,byte 12
	fstp qword [eax+8]
	fstp qword [eax]
.0:    retn

align	4

nan:	dd	0xFFC00000
lim:	dd	36.0
fpcw:	dw	0x1F7F

align	16

;void done(void)
;
_done:	fninit
	mov eax,[sz]
	test eax,eax
	push eax
       jz	.1
       call	_mxDestroyArray
.1:	mov eax,[mn]
	test eax,eax
	mov [esp],eax
       jz	.2
       call	_mxDestroyArray
.2:	mov eax,[mu]
	test eax,eax
	mov [esp],eax
       jz	.3
       call	_mxDestroyArray
.3:	xor eax,eax
	add esp,byte 4
	mov [sz],eax
	mov [mn],eax
	mov [mu],eax
       retn
