/****************************************************************************\
*									     *
*			   Random number generators			     *
*									     *
*									     *
*			Marcel Leutenegger  30.10.2012			     *
*									     *
\****************************************************************************/

#include "mex.h"
#include <math.h>

#ifndef	__random
	#define	__random

	/*	Get an exponentially distributed random number: log(rand).
	*/
	float rande(void);


	/*	Get a normally distributed random number: randn.
	*/
	float randn(void);


	/*	Approximately Poisson distributed random number.
	*/
	float randp(float lambda);


	/*	Get a uniformly distributed random number: rand.
	*/
	float randu(void);


	/*	Initialize random number generators.
	*/
	void init(void);


	/*	Destroy random number generators.
	*/
	void done(void);
#endif
