/****************************************************************************\
*									     *
*	  Random numbers from Poisson distribution for lambda < 36	     *
*	  and from the approximating normal distribution otherwise.	     *
*									     *
*		      Marcel Leutenegger  1.11.2012			     *
*									     *
\****************************************************************************/

#include "random.h"


/*	rnd=randp(lambda)

	Random numbers from approximate Poisson distribution.
*/
void mexFunction(int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[])
{	if (nrhs != 1) mexErrMsgTxt("Invalid number of inputs.");
	if (nlhs > 1) mexErrMsgTxt("Too many output arguments.");
	if (!mxIsSingle(*prhs) || mxIsComplex(*prhs)) mexErrMsgTxt("Lambda must be real single(s).");
	*plhs=mxCreateNumericArray(mxGetNumberOfDimensions(*prhs),mxGetDimensions(*prhs),mxSINGLE_CLASS,mxREAL);
	int n=mxGetNumberOfElements(*prhs);
	if (n > 0)
	{	const float* lambda=mxGetData(*prhs);
		float* rnd=mxGetData(*plhs);
		init();
		while(--n >= 0) rnd[n]=randp(lambda[n]);
	}
}
